Tool: count_tokens
Calculates the number of tokens in a given input without generating a response, helping you manage rate limits and estimate the cost of a request before sending it.
The following sample demonstrate how to use curl to invoke the count_tokens MCP tool.
| Curl Request |
|---|
curl --location 'https://aiplatform.googleapis.com/mcp/generate' \ --header 'content-type: application/json' \ --header 'accept: application/json, text/event-stream' \ --data '{ "method": "tools/call", "params": { "name": "count_tokens", "arguments": { // provide these details according to the tool's MCP specification } }, "jsonrpc": "2.0", "id": 1 }' |
Input Schema
Request message for PredictionService.CountTokens.
CountTokensRequest
| JSON representation |
|---|
{ "endpoint": string, "model": string, "instances": [ value ], "contents": [ { object ( |
| Fields | |
|---|---|
endpoint |
Required. The name of the Endpoint requested to perform token counting. Format: |
model |
Optional. The name of the publisher model requested to serve the prediction. Format: |
instances[] |
Optional. The instances that are the input to token counting call. Schema is identical to the prediction schema of the underlying model. |
contents[] |
Optional. Input content. |
tools[] |
Optional. A list of A |
Union field
|
|
systemInstruction |
Optional. The user provided system instructions for the model. Note: only text should be used in parts and content in each part will be in a separate paragraph. |
Union field
|
|
generationConfig |
Optional. Generation config that the model will use to generate the response. |
Value
| JSON representation |
|---|
{ // Union field |
| Fields | |
|---|---|
Union field kind. The kind of value. kind can be only one of the following: |
|
nullValue |
Represents a JSON |
numberValue |
Represents a JSON number. Must not be |
stringValue |
Represents a JSON string. |
boolValue |
Represents a JSON boolean ( |
structValue |
Represents a JSON object. |
listValue |
Represents a JSON array. |
Struct
| JSON representation |
|---|
{ "fields": { string: value, ... } } |
| Fields | |
|---|---|
fields |
Unordered map of dynamically typed values. An object containing a list of |
FieldsEntry
| JSON representation |
|---|
{ "key": string, "value": value } |
| Fields | |
|---|---|
key |
|
value |
|
ListValue
| JSON representation |
|---|
{ "values": [ value ] } |
| Fields | |
|---|---|
values[] |
Repeated field of dynamically typed values. |
Content
| JSON representation |
|---|
{
"role": string,
"parts": [
{
object ( |
| Fields | |
|---|---|
role |
Optional. The producer of the content. Must be either 'user' or 'model'. If not set, the service will default to 'user'. |
parts[] |
Required. A list of A |
Part
| JSON representation |
|---|
{ "thought": boolean, "thoughtSignature": string, "mediaResolution": { object ( |
| Fields | |
|---|---|
thought |
Optional. Indicates whether the |
thoughtSignature |
Optional. An opaque signature for the thought so it can be reused in subsequent requests. A base64-encoded string. |
mediaResolution |
per part media resolution. Media resolution for the input media. |
Union field
|
|
text |
Optional. The text content of the part. When sent from the VSCode Gemini Code Assist extension, references to @mentioned items will be converted to markdown boldface text. For example |
inlineData |
Optional. The inline data content of the part. This can be used to include images, audio, or video in a request. |
fileData |
Optional. The URI-based data of the part. This can be used to include files from Google Cloud Storage. |
functionCall |
Optional. A predicted function call returned from the model. This contains the name of the function to call and the arguments to pass to the function. |
functionResponse |
Optional. The result of a function call. This is used to provide the model with the result of a function call that it predicted. |
executableCode |
Optional. Code generated by the model that is intended to be executed. |
codeExecutionResult |
Optional. The result of executing the |
Union field
|
|
videoMetadata |
Optional. Video metadata. The metadata should only be specified while the video data is presented in inline_data or file_data. |
Blob
| JSON representation |
|---|
{ "mimeType": string, "data": string, "displayName": string } |
| Fields | |
|---|---|
mimeType |
Required. The IANA standard MIME type of the source data. |
data |
Required. The raw bytes of the data. A base64-encoded string. |
displayName |
Optional. The display name of the blob. Used to provide a label or filename to distinguish blobs. This field is only returned in |
FileData
| JSON representation |
|---|
{ "mimeType": string, "fileUri": string, "displayName": string } |
| Fields | |
|---|---|
mimeType |
Required. The IANA standard MIME type of the source data. |
fileUri |
Required. The URI of the file in Google Cloud Storage. |
displayName |
Optional. The display name of the file. Used to provide a label or filename to distinguish files. This field is only returned in |
FunctionCall
| JSON representation |
|---|
{
"id": string,
"name": string,
"args": {
object
},
"partialArgs": [
{
object ( |
| Fields | |
|---|---|
id |
Optional. The unique id of the function call. If populated, the client to execute the |
name |
Optional. The name of the function to call. Matches |
args |
Optional. The function parameters and values in JSON object format. See |
partialArgs[] |
Optional. The partial argument value of the function call. If provided, represents the arguments/fields that are streamed incrementally. |
willContinue |
Optional. Whether this is the last part of the FunctionCall. If true, another partial message for the current FunctionCall is expected to follow. |
PartialArg
| JSON representation |
|---|
{ "jsonPath": string, "willContinue": boolean, // Union field |
| Fields | |
|---|---|
jsonPath |
Required. A JSON Path (RFC 9535) to the argument being streamed. https://datatracker.ietf.org/doc/html/rfc9535. e.g. "$.foo.bar[0].data". |
willContinue |
Optional. Whether this is not the last part of the same json_path. If true, another PartialArg message for the current json_path is expected to follow. |
Union field delta. The delta of field value being streamed. delta can be only one of the following: |
|
nullValue |
Optional. Represents a null value. |
numberValue |
Optional. Represents a double value. |
stringValue |
Optional. Represents a string value. |
boolValue |
Optional. Represents a boolean value. |
FunctionResponse
| JSON representation |
|---|
{
"id": string,
"name": string,
"response": {
object
},
"parts": [
{
object ( |
| Fields | |
|---|---|
id |
Optional. The id of the function call this response is for. Populated by the client to match the corresponding function call |
name |
Required. The name of the function to call. Matches |
response |
Required. The function response in JSON object format. Use "output" key to specify function output and "error" key to specify error details (if any). If "output" and "error" keys are not specified, then whole "response" is treated as function output. |
parts[] |
Optional. Ordered |
FunctionResponsePart
| JSON representation |
|---|
{ // Union field |
| Fields | |
|---|---|
Union field data. The data of the function response part. data can be only one of the following: |
|
inlineData |
Inline media bytes. |
fileData |
URI based data. |
FunctionResponseBlob
| JSON representation |
|---|
{ "mimeType": string, "data": string, "displayName": string } |
| Fields | |
|---|---|
mimeType |
Required. The IANA standard MIME type of the source data. |
data |
Required. Raw bytes. A base64-encoded string. |
displayName |
Optional. Display name of the blob. Used to provide a label or filename to distinguish blobs. This field is only returned in PromptMessage for prompt management. It is currently used in the Gemini GenerateContent calls only when server side tools (code_execution, google_search, and url_context) are enabled. |
FunctionResponseFileData
| JSON representation |
|---|
{ "mimeType": string, "fileUri": string, "displayName": string } |
| Fields | |
|---|---|
mimeType |
Required. The IANA standard MIME type of the source data. |
fileUri |
Required. URI. |
displayName |
Optional. Display name of the file data. Used to provide a label or filename to distinguish file datas. This field is only returned in PromptMessage for prompt management. It is currently used in the Gemini GenerateContent calls only when server side tools (code_execution, google_search, and url_context) are enabled. |
ExecutableCode
| JSON representation |
|---|
{
"language": enum ( |
| Fields | |
|---|---|
language |
Required. Programming language of the |
code |
Required. The code to be executed. |
CodeExecutionResult
| JSON representation |
|---|
{
"outcome": enum ( |
| Fields | |
|---|---|
outcome |
Required. Outcome of the code execution. |
output |
Optional. Contains stdout when code execution is successful, stderr or other description otherwise. |
VideoMetadata
| JSON representation |
|---|
{ "startOffset": string, "endOffset": string, "fps": number } |
| Fields | |
|---|---|
startOffset |
Optional. The start offset of the video. A duration in seconds with up to nine fractional digits, ending with ' |
endOffset |
Optional. The end offset of the video. A duration in seconds with up to nine fractional digits, ending with ' |
fps |
Optional. The frame rate of the video sent to the model. If not specified, the default value is 1.0. The valid range is (0.0, 24.0]. |
Duration
| JSON representation |
|---|
{ "seconds": string, "nanos": integer } |
| Fields | |
|---|---|
seconds |
Signed seconds of the span of time. Must be from -315,576,000,000 to +315,576,000,000 inclusive. Note: these bounds are computed from: 60 sec/min * 60 min/hr * 24 hr/day * 365.25 days/year * 10000 years |
nanos |
Signed fractions of a second at nanosecond resolution of the span of time. Durations less than one second are represented with a 0 |
MediaResolution
| JSON representation |
|---|
{ // Union field |
| Fields | |
|---|---|
Union field
|
|
level |
The tokenization quality used for given media. |
Tool
| JSON representation |
|---|
{ "functionDeclarations": [ { object ( |
| Fields | |
|---|---|
functionDeclarations[] |
Optional. Function tool type. One or more function declarations to be passed to the model along with the current user query. Model may decide to call a subset of these functions by populating |
retrieval |
Optional. Retrieval tool type. System will always execute the provided retrieval tool(s) to get external knowledge to answer the prompt. Retrieval results are presented to the model for generation. |
googleSearch |
Optional. GoogleSearch tool type. Tool to support Google Search in Model. Powered by Google. |
googleSearchRetrieval |
Optional. Specialized retrieval tool that is powered by Google Search. |
googleMaps |
Optional. GoogleMaps tool type. Tool to support Google Maps in Model. |
enterpriseWebSearch |
Optional. Tool to support searching public web data, powered by Vertex AI Search and Sec4 compliance. |
codeExecution |
Optional. CodeExecution tool type. Enables the model to execute code as part of generation. |
urlContext |
Optional. Tool to support URL context retrieval. |
computerUse |
Optional. Tool to support the model interacting directly with the computer. If enabled, it automatically populates computer-use specific Function Declarations. |
FunctionDeclaration
| JSON representation |
|---|
{ "name": string, "description": string, "parameters": { object ( |
| Fields | |
|---|---|
name |
Required. The name of the function to call. Must start with a letter or an underscore. Must be a-z, A-Z, 0-9, or contain underscores, dots, colons and dashes, with a maximum length of 128. |
description |
Optional. Description and purpose of the function. Model uses it to decide how and whether to call the function. |
parameters |
Optional. Describes the parameters to this function in JSON Schema Object format. Reflects the Open API 3.03 Parameter Object. string Key: the name of the parameter. Parameter names are case sensitive. Schema Value: the Schema defining the type used for the parameter. For function with no parameters, this can be left unset. Parameter names must start with a letter or an underscore and must only contain chars a-z, A-Z, 0-9, or underscores with a maximum length of 64. Example with 1 required and 1 optional parameter: type: OBJECT properties: param1: type: STRING param2: type: INTEGER required: - param1 |
parametersJsonSchema |
Optional. Describes the parameters to the function in JSON Schema format. The schema must describe an object where the properties are the parameters to the function. For example: This field is mutually exclusive with |
response |
Optional. Describes the output from this function in JSON Schema format. Reflects the Open API 3.03 Response Object. The Schema defines the type used for the response value of the function. |
responseJsonSchema |
Optional. Describes the output from this function in JSON Schema format. The value specified by the schema is the response value of the function. This field is mutually exclusive with |
Schema
| JSON representation |
|---|
{ "type": enum ( |
| Fields | |
|---|---|
type |
Optional. Data type of the schema field. |
format |
Optional. The format of the data. For |
title |
Optional. Title for the schema. |
description |
Optional. Describes the data. The model uses this field to understand the purpose of the schema and how to use it. It is a best practice to provide a clear and descriptive explanation for the schema and its properties here, rather than in the prompt. |
nullable |
Optional. Indicates if the value of this field can be null. |
default |
Optional. Default value to use if the field is not specified. |
items |
Optional. If type is |
minItems |
Optional. If type is |
maxItems |
Optional. If type is |
enum[] |
Optional. Possible values of the field. This field can be used to restrict a value to a fixed set of values. To mark a field as an enum, set |
properties |
Optional. If type is An object containing a list of |
propertyOrdering[] |
Optional. Order of properties displayed or used where order matters. This is not a standard field in OpenAPI specification, but can be used to control the order of properties. |
required[] |
Optional. If type is |
minProperties |
Optional. If type is |
maxProperties |
Optional. If type is |
minimum |
Optional. If type is |
maximum |
Optional. If type is |
minLength |
Optional. If type is |
maxLength |
Optional. If type is |
pattern |
Optional. If type is |
example |
Optional. Example of an instance of this schema. |
anyOf[] |
Optional. The instance must be valid against any (one or more) of the subschemas listed in |
additionalProperties |
Optional. If |
ref |
Optional. Allows referencing another schema definition to use in place of this schema. The value must be a valid reference to a schema in For example, the following schema defines a reference to a schema node named "Pet": type: object properties: pet: ref: #/defs/Pet defs: Pet: type: object properties: name: type: string The value of the "pet" property is a reference to the schema node named "Pet". See details in https://json-schema.org/understanding-json-schema/structuring |
defs |
Optional. An object containing a list of |
PropertiesEntry
| JSON representation |
|---|
{
"key": string,
"value": {
object ( |
| Fields | |
|---|---|
key |
|
value |
|
DefsEntry
| JSON representation |
|---|
{
"key": string,
"value": {
object ( |
| Fields | |
|---|---|
key |
|
value |
|
Retrieval
| JSON representation |
|---|
{ "disableAttribution": boolean, // Union field |
| Fields | |
|---|---|
disableAttribution |
Optional. Deprecated. This option is no longer supported. |
Union field source. The source of the retrieval. source can be only one of the following: |
|
vertexAiSearch |
Set to use data source powered by Vertex AI Search. |
vertexRagStore |
Set to use data source powered by Vertex RAG store. User data is uploaded via the VertexRagDataService. |
VertexAISearch
| JSON representation |
|---|
{
"datastore": string,
"engine": string,
"maxResults": integer,
"filter": string,
"dataStoreSpecs": [
{
object ( |
| Fields | |
|---|---|
datastore |
Optional. Fully-qualified Vertex AI Search data store resource ID. Format: |
engine |
Optional. Fully-qualified Vertex AI Search engine resource ID. Format: |
maxResults |
Optional. Number of search results to return per query. The default value is 10. The maximumm allowed value is 10. |
filter |
Optional. Filter strings to be passed to the search API. |
dataStoreSpecs[] |
Specifications that define the specific DataStores to be searched, along with configurations for those data stores. This is only considered for Engines with multiple data stores. It should only be set if engine is used. |
DataStoreSpec
| JSON representation |
|---|
{ "dataStore": string, "filter": string } |
| Fields | |
|---|---|
dataStore |
Full resource name of DataStore, such as Format: |
filter |
Optional. Filter specification to filter documents in the data store specified by data_store field. For more information on filtering, see Filtering |
VertexRagStore
| JSON representation |
|---|
{ "ragCorpora": [ string ], "ragResources": [ { object ( |
| Fields | |
|---|---|
ragCorpora[] |
Optional. Deprecated. Please use rag_resources instead. |
ragResources[] |
Optional. The representation of the rag source. It can be used to specify corpus only or ragfiles. Currently only support one corpus or multiple files from one corpus. In the future we may open up multiple corpora support. |
ragRetrievalConfig |
Optional. The retrieval config for the Rag query. |
storeContext |
Optional. Currently only supported for Gemini Multimodal Live API. In Gemini Multimodal Live API, if |
Union field
|
|
similarityTopK |
Optional. Number of top k results to return from the selected corpora. |
Union field
|
|
vectorDistanceThreshold |
Optional. Only return results with vector distance smaller than the threshold. |
RagResource
| JSON representation |
|---|
{ "ragCorpus": string, "ragFileIds": [ string ] } |
| Fields | |
|---|---|
ragCorpus |
Optional. RagCorpora resource name. Format: |
ragFileIds[] |
Optional. rag_file_id. The files should be in the same rag_corpus set in rag_corpus field. |
RagRetrievalConfig
| JSON representation |
|---|
{ "topK": integer, "hybridSearch": { object ( |
| Fields | |
|---|---|
topK |
Optional. The number of contexts to retrieve. |
hybridSearch |
Optional. Config for Hybrid Search. |
filter |
Optional. Config for filters. |
ranking |
Optional. Config for ranking and reranking. |
HybridSearch
| JSON representation |
|---|
{ // Union field |
| Fields | |
|---|---|
Union field
|
|
alpha |
Optional. Alpha value controls the weight between dense and sparse vector search results. The range is [0, 1], while 0 means sparse vector search only and 1 means dense vector search only. The default value is 0.5 which balances sparse and dense vector search equally. |
Filter
| JSON representation |
|---|
{ "metadataFilter": string, // Union field |
| Fields | |
|---|---|
metadataFilter |
Optional. String for metadata filtering. |
Union field vector_db_threshold. Filter contexts retrieved from the vector DB based on either vector distance or vector similarity. vector_db_threshold can be only one of the following: |
|
vectorDistanceThreshold |
Optional. Only returns contexts with vector distance smaller than the threshold. |
vectorSimilarityThreshold |
Optional. Only returns contexts with vector similarity larger than the threshold. |
Ranking
| JSON representation |
|---|
{ // Union field |
| Fields | |
|---|---|
Union field ranking_config. Config options for ranking. Currently only Rank Service is supported. ranking_config can be only one of the following: |
|
rankService |
Optional. Config for Rank Service. |
llmRanker |
Optional. Config for LlmRanker. |
RankService
| JSON representation |
|---|
{ // Union field |
| Fields | |
|---|---|
Union field
|
|
modelName |
Optional. The model name of the rank service. Format: |
LlmRanker
| JSON representation |
|---|
{ // Union field |
| Fields | |
|---|---|
Union field
|
|
modelName |
Optional. The model name used for ranking. See Supported models. |
GoogleSearch
| JSON representation |
|---|
{ "excludeDomains": [ string ], // Union field |
| Fields | |
|---|---|
excludeDomains[] |
Optional. List of domains to be excluded from the search results. The default limit is 2000 domains. Example: ["amazon.com", "facebook.com"]. |
Union field
|
|
blockingConfidence |
Optional. Sites with confidence level chosen & above this value will be blocked from the search results. |
GoogleSearchRetrieval
| JSON representation |
|---|
{
"dynamicRetrievalConfig": {
object ( |
| Fields | |
|---|---|
dynamicRetrievalConfig |
Specifies the dynamic retrieval configuration for the given source. |
DynamicRetrievalConfig
| JSON representation |
|---|
{ "mode": enum ( |
| Fields | |
|---|---|
mode |
The mode of the predictor to be used in dynamic retrieval. |
Union field
|
|
dynamicThreshold |
Optional. The threshold to be used in dynamic retrieval. If not set, a system default value is used. |
GoogleMaps
| JSON representation |
|---|
{ "enableWidget": boolean } |
| Fields | |
|---|---|
enableWidget |
Optional. If true, include the widget context token in the response. |
EnterpriseWebSearch
| JSON representation |
|---|
{ "excludeDomains": [ string ], // Union field |
| Fields | |
|---|---|
excludeDomains[] |
Optional. List of domains to be excluded from the search results. The default limit is 2000 domains. |
Union field
|
|
blockingConfidence |
Optional. Sites with confidence level chosen & above this value will be blocked from the search results. |
ComputerUse
| JSON representation |
|---|
{
"environment": enum ( |
| Fields | |
|---|---|
environment |
Required. The environment being operated. |
excludedPredefinedFunctions[] |
Optional. By default, predefined functions are included in the final model call. Some of them can be explicitly excluded from being automatically included. This can serve two purposes: 1. Using a more restricted / different action space. 2. Improving the definitions / instructions of predefined functions. |
GenerationConfig
| JSON representation |
|---|
{ "stopSequences": [ string ], "responseMimeType": string, "responseModalities": [ enum ( |
| Fields | |
|---|---|
stopSequences[] |
Optional. A list of character sequences that will stop the model from generating further tokens. If a stop sequence is generated, the output will end at that point. This is useful for controlling the length and structure of the output. For example, you can use ["\n", "###"] to stop generation at a new line or a specific marker. |
responseMimeType |
Optional. The IANA standard MIME type of the response. The model will generate output that conforms to this MIME type. Supported values include 'text/plain' (default) and 'application/json'. The model needs to be prompted to output the appropriate response type, otherwise the behavior is undefined. |
responseModalities[] |
Optional. The modalities of the response. The model will generate a response that includes all the specified modalities. For example, if this is set to |
thinkingConfig |
Optional. Configuration for thinking features. An error will be returned if this field is set for models that don't support thinking. |
modelConfig |
Optional. Config for model selection. |
Union field
|
|
temperature |
Optional. Controls the randomness of the output. A higher temperature results in more creative and diverse responses, while a lower temperature makes the output more predictable and focused. The valid range is (0.0, 2.0]. |
Union field
|
|
topP |
Optional. Specifies the nucleus sampling threshold. The model considers only the smallest set of tokens whose cumulative probability is at least |
Union field
|
|
topK |
Optional. Specifies the top-k sampling threshold. The model considers only the top k most probable tokens for the next token. This can be useful for generating more coherent and less random text. For example, a |
Union field
|
|
candidateCount |
Optional. The number of candidate responses to generate. A higher |
Union field
|
|
maxOutputTokens |
Optional. The maximum number of tokens to generate in the response. A token is approximately four characters. The default value varies by model. This parameter can be used to control the length of the generated text and prevent overly long responses. |
Union field
|
|
responseLogprobs |
Optional. If set to true, the log probabilities of the output tokens are returned. Log probabilities are the logarithm of the probability of a token appearing in the output. A higher log probability means the token is more likely to be generated. This can be useful for analyzing the model's confidence in its own output and for debugging. |
Union field
|
|
logprobs |
Optional. The number of top log probabilities to return for each token. This can be used to see which other tokens were considered likely candidates for a given position. A higher value will return more options, but it will also increase the size of the response. |
Union field
|
|
presencePenalty |
Optional. Penalizes tokens that have already appeared in the generated text. A positive value encourages the model to generate more diverse and less repetitive text. Valid values can range from [-2.0, 2.0]. |
Union field
|
|
frequencyPenalty |
Optional. Penalizes tokens based on their frequency in the generated text. A positive value helps to reduce the repetition of words and phrases. Valid values can range from [-2.0, 2.0]. |
Union field
|
|
seed |
Optional. A seed for the random number generator. By setting a seed, you can make the model's output mostly deterministic. For a given prompt and parameters (like temperature, top_p, etc.), the model will produce the same response every time. However, it's not a guaranteed absolute deterministic behavior. This is different from parameters like |
Union field
|
|
responseSchema |
Optional. Lets you to specify a schema for the model's response, ensuring that the output conforms to a particular structure. This is useful for generating structured data such as JSON. The schema is a subset of the OpenAPI 3.0 schema object object. When this field is set, you must also set the |
Union field
|
|
responseJsonSchema |
Optional. When this field is set, |
Union field
|
|
routingConfig |
Optional. Routing configuration. |
Union field
|
|
audioTimestamp |
Optional. If enabled, audio timestamps will be included in the request to the model. This can be useful for synchronizing audio with other modalities in the response. |
Union field
|
|
mediaResolution |
Optional. The token resolution at which input media content is sampled. This is used to control the trade-off between the quality of the response and the number of tokens used to represent the media. A higher resolution allows the model to perceive more detail, which can lead to a more nuanced response, but it will also use more tokens. This does not affect the image dimensions sent to the model. |
Union field
|
|
speechConfig |
Optional. The speech generation config. |
Union field
|
|
enableAffectiveDialog |
Optional. If enabled, the model will detect emotions and adapt its responses accordingly. For example, if the model detects that the user is frustrated, it may provide a more empathetic response. |
Union field
|
|
imageConfig |
Optional. Config for image generation features. |
RoutingConfig
| JSON representation |
|---|
{ // Union field |
| Fields | |
|---|---|
Union field routing_config. The routing mode for the request. routing_config can be only one of the following: |
|
autoMode |
In this mode, the model is selected automatically based on the content of the request. |
manualMode |
In this mode, the model is specified manually. |
AutoRoutingMode
| JSON representation |
|---|
{ // Union field |
| Fields | |
|---|---|
Union field
|
|
modelRoutingPreference |
The model routing preference. |
ManualRoutingMode
| JSON representation |
|---|
{ // Union field |
| Fields | |
|---|---|
Union field
|
|
modelName |
The name of the model to use. Only public LLM models are accepted. |
SpeechConfig
| JSON representation |
|---|
{ "voiceConfig": { object ( |
| Fields | |
|---|---|
voiceConfig |
The configuration for the voice to use. |
languageCode |
Optional. The language code (ISO 639-1) for the speech synthesis. |
multiSpeakerVoiceConfig |
The configuration for a multi-speaker text-to-speech request. This field is mutually exclusive with |
VoiceConfig
| JSON representation |
|---|
{ // Union field |
| Fields | |
|---|---|
Union field voice_config. The configuration for the speaker to use. voice_config can be only one of the following: |
|
prebuiltVoiceConfig |
The configuration for a prebuilt voice. |
replicatedVoiceConfig |
Optional. The configuration for a replicated voice. This enables users to replicate a voice from an audio sample. |
PrebuiltVoiceConfig
| JSON representation |
|---|
{ // Union field |
| Fields | |
|---|---|
Union field
|
|
voiceName |
The name of the prebuilt voice to use. |
ReplicatedVoiceConfig
| JSON representation |
|---|
{ "mimeType": string, "voiceSampleAudio": string } |
| Fields | |
|---|---|
mimeType |
Optional. The mimetype of the voice sample. The only currently supported value is |
voiceSampleAudio |
Optional. The sample of the custom voice. A base64-encoded string. |
MultiSpeakerVoiceConfig
| JSON representation |
|---|
{
"speakerVoiceConfigs": [
{
object ( |
| Fields | |
|---|---|
speakerVoiceConfigs[] |
Required. A list of configurations for the voices of the speakers. Exactly two speaker voice configurations must be provided. |
SpeakerVoiceConfig
| JSON representation |
|---|
{
"speaker": string,
"voiceConfig": {
object ( |
| Fields | |
|---|---|
speaker |
Required. The name of the speaker. This should be the same as the speaker name used in the prompt. |
voiceConfig |
Required. The configuration for the voice of this speaker. |
ThinkingConfig
| JSON representation |
|---|
{ // Union field |
| Fields | |
|---|---|
Union field
|
|
includeThoughts |
Optional. If true, the model will include its thoughts in the response. "Thoughts" are the intermediate steps the model takes to arrive at the final response. They can provide insights into the model's reasoning process and help with debugging. If this is true, thoughts are returned only when available. |
Union field
|
|
thinkingBudget |
Optional. The token budget for the model's thinking process. The model will make a best effort to stay within this budget. This can be used to control the trade-off between response quality and latency. |
Union field
|
|
thinkingLevel |
Optional. The number of thoughts tokens that the model should generate. |
ModelConfig
| JSON representation |
|---|
{
"featureSelectionPreference": enum ( |
| Fields | |
|---|---|
featureSelectionPreference |
Required. Feature selection preference. |
ImageConfig
| JSON representation |
|---|
{ // Union field |
| Fields | |
|---|---|
Union field
|
|
imageOutputOptions |
Optional. The image output format for generated images. |
Union field
|
|
aspectRatio |
Optional. The desired aspect ratio for the generated images. The following aspect ratios are supported: "1:1" "2:3", "3:2" "3:4", "4:3" "4:5", "5:4" "9:16", "16:9" "21:9" |
Union field
|
|
personGeneration |
Optional. Controls whether the model can generate people. |
Union field
|
|
imageSize |
Optional. Specifies the size of generated images. Supported values are |
ImageOutputOptions
| JSON representation |
|---|
{ // Union field |
| Fields | |
|---|---|
Union field
|
|
mimeType |
Optional. The image format that the output should be saved as. |
Union field
|
|
compressionQuality |
Optional. The compression quality of the output image. |
Output Schema
Response message for PredictionService.CountTokens.
CountTokensResponse
| JSON representation |
|---|
{
"totalTokens": integer,
"totalBillableCharacters": integer,
"promptTokensDetails": [
{
object ( |
| Fields | |
|---|---|
totalTokens |
The total number of tokens counted across all instances from the request. |
totalBillableCharacters |
The total number of billable characters counted across all instances from the request. |
promptTokensDetails[] |
Output only. List of modalities that were processed in the request input. |
ModalityTokenCount
| JSON representation |
|---|
{
"modality": enum ( |
| Fields | |
|---|---|
modality |
The modality that this token count applies to. |
tokenCount |
The number of tokens counted for this modality. |
Tool Annotations
Destructive Hint: ❌ | Idempotent Hint: ✅ | Read Only Hint: ✅ | Open World Hint: ❌